/*
	Copyright 2014 Li-Cheng (Andy) Tai
                      atai@atai.org
                      
	gsimple_panel is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	gsimple_panel is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	gsimple_panel. If not, see http://www.gnu.org/licenses/.


*/

using GLib;
using Pango;
using Gtk;
using Gee;
using Wnck;

void on_quit()
{
    Wnck.shutdown();
    Gtk.main_quit();
    
}

Gtk.Label time_display = null;


bool time_update()
{
    Time t = Time.local(time_t());
    
    string text = "<span font=\"Sans 15\"  foreground=\"red\"><b> " + t.format("%X") + " </b></span>";
    time_display.set_label(text);
    return true;    
}
int main(string[] args)
{	
    
    Gtk.init(ref args);
	Wnck.set_client_type(Wnck.ClientType.PAGER);

	Gtk.Window window = new Gtk.Window();
	window.decorated = false;

	Wnck.Tasklist task_list = new Wnck.Tasklist();
	
	task_list.set_button_relief(Gtk.ReliefStyle.NORMAL);
	task_list.set_grouping(Wnck.TasklistGroupingType.ALWAYS_GROUP);
	Gtk.Box panel = new Gtk.Box(Gtk.Orientation.HORIZONTAL, 4);
	panel.pack_start(new Gtk.Label(""), false, false, 0);
	panel.pack_start(task_list, true, true, 4);
	
	// clock display setup
	Gtk.Frame frame = new Gtk.Frame(null);
	frame.set_shadow_type(Gtk.ShadowType.IN);
	time_display = new Gtk.Label("");
	frame.add(time_display);
	
	time_display.set_use_markup(true);
    // update the clock once a second
    Timeout.add (1000, time_update);
	time_update();
	
	// end clock display setup 
	panel.pack_end(frame, false, false, 1);

	Gtk.Frame frame2 = new Gtk.Frame(null);
	frame2.set_shadow_type(Gtk.ShadowType.ETCHED_OUT);
	frame2.add(panel);
	window.add(frame2);
	
	Gdk.Display display = Gdk.Display.get_default();
	Gdk.Screen screen = display.get_default_screen();
	Gdk.Geometry hints = {};
	hints.max_width = screen.get_width();
	hints.max_height = -1;
	window.set_geometry_hints(null, hints, Gdk.WindowHints.MAX_SIZE);
	window.set_keep_above(true);
	window.set_gravity(Gdk.Gravity.SOUTH_WEST);
	window.move(0, screen.get_height());
	window.show_all();
	
	window.destroy.connect(on_quit);
	Gtk.main();
	return 0;
}

